#include <debug.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

#define SIZE 30068


int fd;

unsigned char *pic;


int i;
int rc;

// ASCII P3 PPM

int dump_ppm3(char *f)
{
int i;
int size;
int w,h;

fh_jpeg_getsize(f,&w,&h);
size=w*h*3;
debug("%s: %i x %i\n",f,w,h);
pic=(unsigned char*) malloc(w*h*3);
fh_jpeg_load(f,pic,w,h);

printf("P3\n");
printf("#bubbazza Inc\n");
printf("%d %d\n",w,h);
printf("255\n");

i=0;
for (; i<size; i=i+3) {
printf("%d %d %d ",pic[i],pic[i+1],pic[i+2]);
if ((i % 4 == 0) && (i>1) ) printf("\n");
}
printf("\n");

}

// rawbits P6 PPM

int dump_ppm6(char *f)
{
int i;
int size;
int w,h;
char format[20];

fh_jpeg_getsize(f,&w,&h);
size=w*h*3;
debug("%s: %i x %i\n",f,w,h);
pic=(unsigned char*) malloc(w*h*3);
fh_jpeg_load(f,pic,w,h);

printf("P6\n");
//printf("#bubbazza Inc\n");
printf("%d %d\n",w,h);
printf("%d\n",255);

sprintf(format,"%%%ic\n",size);
//printf("%s",pic);
for (i=0; i<size;i++ ) printf("%c",pic[i]);
}





int dump_rgb(char *f)
{
int w,h;
fh_jpeg_getsize(f,&w,&h);
debug("%s: %i x %i\n",f,w,h);
pic=(unsigned char*) malloc(w*h*3);
fh_jpeg_load(f,pic,w,h);
write(1,pic,w*h*3);
}

main(int argc, char *argv[])
{
char *opt=0, *filename=0;

filename=argv[1];
opt=argv[2];
if  (opt == 0 ) opt="ppm6";

if ( filename ==0 ) {
	fprintf(stderr,"Convert jpg-> rgb|ppm3|[ppm6], (C) 2002 M.Andreoli \n");
	fprintf(stderr,"N1: ppm6 is the rawbits format. \n");
	fprintf(stderr,"N2: Result is in the stdout. \n");
	fprintf(stderr,"Usage: %s filename rgb|ppm3|[ppm6] \n","j2");
	exit(1);
}


debug("filename(%s): %s -> %s\n",filename,"jpeg",opt);

if (! strcmp(opt,"rgb") ) { dump_rgb(filename); exit;}
if (! strcmp(opt,"ppm3") ) { dump_ppm3(filename); exit;}
if (! strcmp(opt,"ppm6") ) { dump_ppm6(filename); exit;}

}
